# -*- coding: utf-8 -*-
'''
MediaBox Widget
2010(c) Kirill Plyashkevich <ru.spirit@gmail.com>
Maemo 5 home item
'''

import gtk, hildon
from abstract import AbstractMediaBoxWidget
from hildondesktop import HomePluginItem

class MediaBoxWidgetMaemo5(AbstractMediaBoxWidget, HomePluginItem):

  def __init__(self):
    AbstractMediaBoxWidget.__init__(self)
    #self.start_command = 'dbus-send --session --dest=com.nokia.HildonDesktop.AppMgr --type=method_call /com/nokia/HildonDesktop/AppMgr com.nokia.HildonDesktop.AppMgr.LaunchApplication string:MediaBox'

  def __super_init__(self):
    HomePluginItem.__init__(self)

  def __custom_init__(self):
    self.settings_dialog_buttons = (gtk.STOCK_SAVE, gtk.RESPONSE_OK)
    self.set_settings(True)
    self.connect('property-notify-event', self.on_current_desktop)
    self.connect('show-settings', self.show_settings_dialog)

  def __show_all__(self):
    self.widget_box.show_all()

  def on_current_desktop(self, widget, event):
    if event.atom == '_HILDON_APPLET_ON_CURRENT_DESKTOP':
      result = event.state.value_nick == 'new-value'
      self.update_widgets_activity(result)
    return False

  def do_realize(self):
    self.screen_changed(self)
    HomePluginItem.do_realize(self)
    return False

  def __create_settings_control__(self, config_key):
    name, ck_type, value = self._config.get_entry(config_key)
    config_control = None
    if ck_type == type(None):
      pass
    elif ck_type == bool:
      config_control = hildon.CheckButton(gtk.HILDON_SIZE_HALFSCREEN_WIDTH | gtk.HILDON_SIZE_FINGER_HEIGHT)
      config_control.set_label(self._lcl.get(config_key))
      config_control.set_active(value)
    elif ck_type == list:
      config_control = hildon.PickerButton(gtk.HILDON_SIZE_HALFSCREEN_WIDTH | gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_VERTICAL)
      config_control.set_title(self._lcl.get(config_key))
      config_control.set_alignment(0, 0.5, 0, 0)
      config_control.set_value('%s' % (value))
    elif ck_type == tuple:
      config_control = hildon.PickerButton(gtk.HILDON_SIZE_HALFSCREEN_WIDTH | gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_VERTICAL)
    elif ck_type == dict:
      config_control = hildon.PickerButton(gtk.HILDON_SIZE_HALFSCREEN_WIDTH | gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_VERTICAL)
    else:
      config_control = hildon.PickerButton(gtk.HILDON_SIZE_HALFSCREEN_WIDTH | gtk.HILDON_SIZE_FINGER_HEIGHT, hildon.BUTTON_ARRANGEMENT_VERTICAL)
      config_control.set_title(self._lcl.get(config_key))
      config_control.set_alignment(0, 0.5, 0, 0)
      config_ts = hildon.TouchSelector()
      config_control.set_selector(config_ts)
      config_list_store = gtk.ListStore(str, ck_type)
      config_options = self._config.get_option(config_key)
      config_ts.append_text_column(config_list_store, True)
      config_ts.set_column_selection_mode(hildon.TOUCH_SELECTOR_SELECTION_MODE_SINGLE)
      if config_options:
        for config_option in config_options:
          config_list_store.append([self._lcl.get(str(config_option)), config_option])
        if not value in config_options:
          config_list_store.append([self._lcl.get(str(value)), value])
        config_control.set_active(config_options.index(value))
      else:
        config_list_store.append([self._lcl.get(str(value)), value])
        config_control.set_active(0)
    return config_control

  def __get_settings_control_value__(self, config_key, control):
    name, ck_type, value = self._config.get_entry(config_key)
    if ck_type == bool:
      value = control.get_active()
    elif ck_type == list:
      pass
    else:
      ts = self.__config_controls[config_key].get_selector()
      model = ts.get_model(0)
      citer = model.get_iter_first()
      ts.get_selected(0, citer)
      value = ck_type(model.get_value(citer, 1))
    return value

  def __get_settings_area__(self):
    return hildon.PannableArea()

def get_hd_plugin_type(): return MediaBoxWidgetMaemo5
